#include <vhex/keyboard/keyvent.h>
#include <vhex/keyboard/keycache.h>

/* keyvent_poll(): Poll the next keyboard event */
key_event_t keyvent_poll(void)
{
	key_event_t e;

	keycache_event_pop(&e);
	return e;
}

/* waitevent(): Wait for the next keyboard event */
key_event_t keyvent_wait(volatile int *timeout)
{
	key_event_t e;

	keycache_event_wait(&e, timeout);
	return e;
}

/* clearevents(): Clear all events waiting in the queue */
void keyvent_clear(void)
{
	key_event_t e;

	while (1) {
		e = keyvent_poll();
		if (e.type == KEYEV_NONE)
			break;
	}
}
